part of tecfy_core_client_package;

class ReportProperty {
  late String dbName;
  late ValueTypes type;
  Property? property;
  String? propertyCode;
  String? parentPropertyId;
  String? childPropertyId;
  late String nameAr;
  late String nameEn;
  String? format;
  late bool sortable;
  bool isVisible = true;
  int sortId = 0;
  String? reportEntityName;

  String? colorField;
  String? color;
  String? prefixField;
  String? suffixField;
  String? prefix;
  String? suffix;

  String? drillDownEntity;
  String? drillDownIdField;
  bool drillDownEntityDynamic = false;

  String? descriptionAr;
  String? descriptionEn;

  /// get the name according to login language
  String? get description => LocalConfigService.isArabic
      ? (descriptionAr ?? descriptionEn)
      : (descriptionEn ?? descriptionAr);

  /// get the name according to login language
  String get name => LocalConfigService.isArabic ? nameAr : nameEn;

  ReportProperty(
      {this.dbName = '',
      this.nameEn = '',
      this.type = ValueTypes.Number,
      required this.isVisible,
      this.nameAr = ''});

  ReportProperty.fromMap(Map<String, dynamic> row, this.reportEntityName) {
    dbName = lowerFirst(row['dbName']) ?? '';
    if (dbName.contains('.')) {
      // var reportEntity = EntityService.getEntity(reportEntityName);
      // var firstProp = reportEntity?.propertiesMap[this.dbName.split('.').first];
      // parentPropertyId =
      //     EntityService.lowerFirst((firstProp as PropertyDropdown).entityName);
      parentPropertyId = this.dbName.split('.').first;
      if (parentPropertyId!.endsWith('Id')) {
        parentPropertyId =
            parentPropertyId?.substring(0, parentPropertyId!.length - 2);
      }
      childPropertyId = EntityService.lowerFirst(this.dbName.split('.').last);
    }

    type = ValueTypes.values[row['type']];
    if (row['property'] != null) {
      property = Property.getProperty(row['property']);
    }
    propertyCode = row['propertyCode'];
    nameAr = row['nameAr'] ?? dbName;
    nameEn = row['nameEn'] ?? dbName;
    descriptionAr = row['descriptionAr'];
    descriptionEn = row['descriptionEn'];
    drillDownEntity = lowerFirst(row['drillDownEntity']);
    drillDownIdField = lowerFirst(row['drillDownIdField']);
    drillDownEntityDynamic = row['drillDownEntityDynamic'] ?? false;
    format = row['format'];
    if (format?.isEmpty ?? false) format = null;
    sortable = row['sortable'] ?? false;
    sortId = row['sortId'] ?? 0;
    colorField = lowerFirst(row['colorField']);
    color = row['color'];
    prefixField = row['prefixField'];
    suffixField = row['suffixField'];
    prefix = row['prefix'];
    suffix = row['suffix'];
    isVisible = !(row['isExtraColumn'] ?? false);
  }

  String? lowerFirst(String? s) {
    if (s == null || s.isEmpty) return '';
    return '${s[0].toLowerCase()}${s.substring(1)}';
  }

  String? upperFirst(String? s) {
    if (s == null || s.isEmpty) return '';
    return '${s[0].toUpperCase()}${s.substring(1)}';
  }
}
