part of tecfy_core_client_package;

class ExcelService {
  static Future generateExcel(
      List<ReportProperty> props, List<Map<String, dynamic>> data,
      {String fileName = 'report'}) async {
    var excel = Excel.createExcel();
    var sheet = excel.sheets[excel.getDefaultSheet()]!;

    for (int ci = 0; ci < props.length; ci++) {
      sheet.insertColumn(ci);
    }
    sheet.insertRow(0);
    for (int ri = 0; ri < data.length; ri++) {
      sheet.insertRow(ri + 1);
    }

    for (int ci = 0; ci < props.length; ci++) {
      sheet.updateCell(CellIndex.indexByColumnRow(columnIndex: ci, rowIndex: 0),
          props[ci].name,
          cellStyle: CellStyle(
              backgroundColorHex: 'FF000000', fontColorHex: 'FFFFFFFF'));
    }

    for (int ri = 0; ri < data.length; ri++) {
      for (int ci = 0; ci < props.length; ci++) {
        sheet.updateCell(
          CellIndex.indexByColumnRow(columnIndex: ci, rowIndex: ri + 1),
          data[ri][props[ci].dbName],
        );
      }
    }
    var fileFullName =
        '$fileName ${intl.DateFormat("yyyy-MM-dd HH:mm").format(DateTime.now())}.xlsx';
    var fileBytes = excel.save(fileName: fileFullName);
    print('*************************************************************');
    print('------------------------------------------- ${DateTime.now()}');
    if (fileBytes != null) {
      Share.shareXFiles(
        [
          XFile.fromData(
            Uint8List.fromList(fileBytes),
            mimeType: 'application/vnd-xls',
            name: fileFullName,
          )
        ],
        text: fileFullName,
        subject: fileFullName,
      );
      // await Printing.sharePdf(
      //   bytes: Uint8List.fromList(fileBytes),
      //   filename: fileFullName,
      //   body: '',
      //   subject: fileFullName,
      //   emails: [],
      // );
    }
  }
}
