part of tecfy_core_client_package;

class MainAppBar extends AppBar {
  MainAppBar(
      {context,
      PreferredSizeWidget? bottom,
      IconData? backButtonIcon,
      backButtonFunction,
      required String title,
      List<Widget>? actions,
      Color? backgroundColor,
      bool isHome = false})
      : assert(context != null),
        super(
          actions: actions,
          backgroundColor: backgroundColor,
          centerTitle: true,
          leading: backButtonIcon == null
              ? Navigator.of(context).canPop() && !isHome
                  ? IconButton(
                      onPressed: () => Navigator.of(context).pop(),
                      icon: Icon(Icons.arrow_back))
                  : Builder(
                      builder: (context) => IconButton(
                          onPressed: () => Scaffold.of(context).openDrawer(),
                          icon: Icon(Icons.menu)))
              : IconButton(
                  onPressed:
                      backButtonFunction ?? () => Navigator.of(context).pop(),
                  icon: Icon(backButtonIcon)),
          elevation: 0.0,
          surfaceTintColor: Colors.white,
          shadowColor: Colors.white,
          bottom: bottom,
          iconTheme: IconThemeData(color: ThemeService.mainColor),
          actionsIconTheme: IconThemeData(color: ThemeService.mainColor),
          title: TecfyText(
            title,
            style: TextStyle(color: ThemeService.mainColor),
          ),
        );
}
