part of tecfy_core_client_package;

class SettingPage extends StatefulWidget {
  final bool isPopup;
  SettingPage(this.isPopup, {Key? key}) : super(key: key);
  @override
  _SettingPageState createState() => _SettingPageState();
}

class _SettingPageState extends TecfyAppState<SettingPage> {
  @override
  void initState() {
    Map<String, dynamic> colors = ConfigService.getValueMap('appColors');
    if (colors.isNotEmpty) {
      colorModel = ColorModel.fromJson(colors);
    } else {
      colorModel = ColorModel();
    }
    super.initState();
  }

  late ColorModel colorModel;

  @override
  Widget build(BuildContext context) {
    return widget.isPopup
        ? _getBody()
        : BasePage(
            context,
            AppLocale.translate('Settings'),
            'settings',
            isMobile: LayoutService.isMobile(context),
            child: _getBody(),
          );
  }

  Widget _chooseColor({
    required String name,
    required Color initColor,
    required Function(Color color) onColorChange,
  }) {
    return Padding(
      padding: EdgeInsets.all(20),
      child: Row(
        children: [
          Text(name),
          Spacer(),
          ColorIndicator(
            color: initColor,
            onSelect: () {
              AppNavigator.showAppDialogEx(
                  context,
                  () => StatefulBuilder(
                        builder: (context, setStateDialog) => Column(
                          children: [
                            // MaterialColorPicker(
                            //   circleSize: 140,
                            //   selectedColor:
                            //  initColor,
                            //   onColorChange: (color) {
                            //     onColorChange(color);
                            //     // colorModel =  ColorModel
                            //     //   (worningColor:
                            //     // color.value);
                            //     // print(colorModel.toJson());
                            //     //
                            //     // setState(() {
                            //     // });
                            //   },
                            // ),
                            SingleChildScrollView(
                              child: ColorPicker(
                                onColorChanged: (color) {},
                                color: initColor,
                                onColorChangeEnd: (color) {
                                  initColor = color;
                                  setStateDialog(() {});
                                },
                                // actionButtons: ColorPickerActionButtons(),
                                pickerTypeLabels: {
                                  ColorPickerType.primary: 'أساسي',
                                  ColorPickerType.wheel: 'عجله'
                                },
                                selectedPickerTypeColor: initColor,
                                borderColor: initColor,
                                pickersEnabled: {
                                  ColorPickerType.accent: false,
                                  ColorPickerType.wheel: true,
                                },
                              ),
                            ),
                            MaterialButton(
                                onPressed: () {
                                  onColorChange(initColor);
                                  Navigator.pop(context, initColor);
                                },
                                child: Text(trans('Save'))),
                          ],
                        ),
                      ));
            },
            elevation: 5,
          ),
          // CircleColor(
          //   color:  initColor,
          //   circleSize: 40,
          //   onColorChoose: (color) {
          //     AppNavigator.showAppDialogEx(
          //         context,
          //             () => Column(
          //           children: [
          //             // MaterialColorPicker(
          //             //   circleSize: 140,
          //             //   selectedColor:
          //             //  initColor,
          //             //   onColorChange: (color) {
          //             //     onColorChange(color);
          //             //     // colorModel =  ColorModel
          //             //     //   (worningColor:
          //             //     // color.value);
          //             //     // print(colorModel.toJson());
          //             //     //
          //             //     // setState(() {
          //             //     // });
          //             //   },
          //             // ),
          //             SingleChildScrollView(
          //                 child:ColorPicker(
          //                   onColorChanged: (color){
          //                     setState(() {
          //                       onColorChange(color);
          //                     });
          //                   },
          //              color: initColor,
          //                   onColorChangeEnd: (color){
          //                     initColor = color;
          //                     setState(() {
          //
          //                     });
          //                   },
          //               // actionButtons: ColorPickerActionButtons(),
          //               pickerTypeLabels: {
          //                     ColorPickerType.primary:'أساسي',
          //                 ColorPickerType.wheel:'عجله'
          //               },
          //               selectedPickerTypeColor: initColor,
          //                borderColor: initColor,
          //                pickersEnabled:
          //               {ColorPickerType.accent:false,
          //                 ColorPickerType.wheel:true,
          //               },
          //              ),
          //             ),
          //           ],
          //         )).then((value) {
          //       setState(() {
          //         print('FFFFFFFFFFFFFFFFFFFFFFFFFFFFF');
          //       });
          //     });
          //     //    print(color);ذ
          //
          //   },
          //
          // ),
        ],
      ),
    );
  }

  Widget _getBody() {
    return SingleChildScrollView(
        child: Column(
      children: <Widget>[
        SizedBox(height: 15.0),
        _getItem(
            'Language',
            DropdownButtonHideUnderline(
                child: DropdownButton<Language>(
              value: LocalConfigService.language,
              items: [
                DropdownMenuItem(
                    child: TecfyText(trans('عربي')), value: Language.arabic),
                DropdownMenuItem(
                    child: TecfyText('English'), value: Language.english)
              ],
              onChanged: (v) async {
                LocalConfigService.language = v ?? Language.arabic;
                // if (v == Language.arabic) {
                //   AppNavigator.showLoading(context);
                //   await InitService.afterLoginInit();
                // }
              },
            )),
            null),
        SizedBox(height: 15.0),
        _getItem(
            'Connection Status',
            Row(
              children: <Widget>[
                TecfyText(trans('Status')),
                TecfyText(':'),
                SizedBox(width: 15.0),
                ConnectionService.getConnectionIconStream(),
              ],
            ),
            null),
        SizedBox(height: 15.0),
        _getItem(
            'Lock Timeout',
            DropdownButtonHideUnderline(
                child: DropdownButton(
              value: ConfigService.getValueInt('LockTimeout'),
              items: [
                DropdownMenuItem(child: TecfyText(trans('Never')), value: 0),
                DropdownMenuItem(child: TecfyText(trans('30s')), value: 30),
                DropdownMenuItem(
                    child: TecfyText(trans('10m')), value: 10 * 60),
                DropdownMenuItem(child: TecfyText('30m'), value: 30 * 60),
                DropdownMenuItem(child: TecfyText('1h'), value: 60 * 60),
              ],
              onChanged: (int? v) async {
                // setState((){});
                await ConfigService.setValueInt('LockTimeout', v!);
                AppLocale.languageStreamController.add(
                    LocalConfigService.isArabic
                        ? Language.arabic
                        : Language.english);
              },
            )),
            null,
            tooltipMessage: LocalConfigService.isArabic
                ? 'قفل '
                    'البرنامج لمدة معينة لحماية بيانات حسابك'
                : 'Lock Program for '
                    'specific time to secure your account'),
        SizedBox(
          height: 15.0,
        ),
        !PlatformService.isSupportLocalDBSupported
            ? Container()
            : _getItem(
                'Operation Mode',
                Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Expanded(
                          child: DropdownButtonHideUnderline(
                              child: DropdownButton<OperationMode>(
                        value: LocalConfigService.operationMode,
                        items: [
                          DropdownMenuItem(
                              child: TecfyText(trans('Online Mode')),
                              value: OperationMode.online),
                          DropdownMenuItem(
                              child: TecfyText(
                                  trans('Offline: Cache Required Data Only')),
                              value: OperationMode.offline_cache_required),
                          DropdownMenuItem(
                              child: TecfyText(trans('Offline: Cache Last 3 '
                                  'months')),
                              value: OperationMode.offline_cache_3months),
                          DropdownMenuItem(
                              child: TecfyText(trans('Offline: Cache Last 6 '
                                  'months')),
                              value: OperationMode.offline_cache_6months),
                          DropdownMenuItem(
                              child: TecfyText(trans('Offline: Cache Last 12 '
                                  'months')),
                              value: OperationMode.offline_cache_12months),
                          DropdownMenuItem(
                              child: TecfyText(trans('Offline: Cache All '
                                  'Data')),
                              value: OperationMode.offline_cache_all),
                        ],
                        onChanged: (v) async {
                          if (LocalConfigService.operationMode !=
                                  OperationMode.online &&
                              v == OperationMode.online) {
                            // make sure nothing in cache
                            try {
                              int pending =
                                  await TecfySyncService.getUnpostedCount();
                              if (pending > 0) {
                                var result = await AppNavigator.confirmMessage(
                                    context,
                                    'You have $pending local items not posted to server!!!!',
                                    message: AppLocale.translate(
                                        'Are you sure you want to logout?'));
                                if (!result) return;
                              }
                            } catch (e) {}
                          } else if (LocalConfigService.operationMode ==
                                  OperationMode.online &&
                              v != OperationMode.online) {
                            // re-create database
                            LocalConfigService.operationMode =
                                v ?? OperationMode.online;
                            AppNavigator.showLoading(context);
                            await DatabaseService.deleteDatabaseFile();
                            await EntityService.initEntities();
                            await DatabaseService.init();
                            AppNavigator.pop(context);
                          }
                          LocalConfigService.operationMode =
                              v ?? OperationMode.online;
                          setState(() {});
                        },
                      ))),
                    ]),
                LocalConfigService.operationMode != OperationMode.online
                    ? IconButton(
                        tooltip: trans('Show'),
                        icon: Icon(Icons.remove_red_eye_outlined),
                        onPressed: () async {
                          await AppNavigator.navigateTo(
                              context, () => LocalRecordsPage());
                        })
                    : Container()),
        SizedBox(height: 15.0),
        ConnectionService.isOnlineMode
            ? SizedBox()
            : _getItem(
                'Unposted Items',
                Row(
                  children: <Widget>[
                    TecfyText(trans('Unposted Items')),
                    Expanded(child: SizedBox()),
                    TecfySyncService.getSyncIcon(context, false),
                  ],
                ),
                IconButton(
                    tooltip: trans('Show'),
                    icon: Icon(Icons.remove_red_eye_outlined),
                    onPressed: () async {
                      await AppNavigator.navigateTo(context, () => SyncPage());
                    })),
        SizedBox(height: 15.0),
        if (TecfyCoreApp.menuService != null)
          FutureBuilder<List<Widget>>(
            future: TecfyCoreApp.menuService!.settingsCards(context),
            builder: (context, snapshot) {
              if (snapshot.hasData)
                return Column(
                  children: snapshot.data!,
                );
              if (snapshot.hasError)
                return SizedBox();
              else
                return SizedBox();
            },
          ),
        _getItem(
            'Account Settings',
            Row(
              children: <Widget>[
                TecfyText(trans('Name')),
                TecfyText(':'),
                SizedBox(width: 15.0),
                Expanded(
                    child: TecfyText(
                  LocalConfigService.user?.fullName ?? trans("Guest"),
                  maxLines: 1,
                  softWrap: true,
                  overflow: TextOverflow.clip,
                )),
              ],
            ),
            IconButton(
                tooltip: trans('Update Info'),
                icon: Icon(Icons.edit),
                onPressed: () async {
                  await AppNavigator.navigateTo(context, () => AccountPage());
                })),
        SizedBox(height: 15.0),
        _getItem(
            'Enable Expert Mode',
            Switch(
                value: ConfigService.getValueBool('ExpertMode'),
                onChanged: (v) {
                  ConfigService.setValueBool('ExpertMode', v);
                  setState(() {});
                }),
            null),
        SizedBox(height: 15.0),
        _getItem(
            'تغير ألوان البرنامج',
            TextButton(
                onPressed: () {
                  AppNavigator.showAppDialogEx(
                    context,
                    () => Scaffold(
                      body: StatefulBuilder(
                        builder: (context, setState) => SingleChildScrollView(
                          child: Column(
                            children: [
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'اللون الرئيسي'
                                      : 'Main'
                                          ' Color',
                                  initColor: colorModel.secondColor != null
                                      ? Color(colorModel.secondColor!)
                                      : ThemeService.secondryColor,
                                  onColorChange: (color) {
                                    colorModel.secondColor = color.value;
                                    setState(() {});
                                    print(colorModel.toJson());
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'اللون الفرعي'
                                      : 'Sub Color',
                                  initColor: colorModel.subColor != null
                                      ? Color(colorModel.subColor!)
                                      : ThemeService.subColor,
                                  onColorChange: (color) {
                                    // print('subColor = $color');
                                    colorModel.subColor = color.value;
                                    print(colorModel.toJson());

                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'لون الخط الرئيسي'
                                      : 'Main font color',
                                  initColor: colorModel.textMainColor != null
                                      ? Color(colorModel.textMainColor!)
                                      : ThemeService.mainTextColor,
                                  onColorChange: (color) {
                                    colorModel.textMainColor = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'لون الخط '
                                          'الفرعي'
                                      : 'Sub font Color',
                                  initColor: colorModel.textSubColor != null
                                      ? Color(colorModel.textSubColor!)
                                      : ThemeService.textSubColor,
                                  onColorChange: (color) {
                                    colorModel.textSubColor = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'لون '
                                          'الخلفية'
                                      : 'Background Color',
                                  initColor: colorModel.backgroundColor != null
                                      ? Color(colorModel.backgroundColor!)
                                      : ThemeService.backgroundColor,
                                  onColorChange: (color) {
                                    colorModel.backgroundColor = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'لون '
                                          'الخلفية الثاني'
                                      : 'Background Second Color',
                                  initColor: colorModel.backgroundSecondColor !=
                                          null
                                      ? Color(colorModel.backgroundSecondColor!)
                                      : ThemeService.backgroundSecondColor,
                                  onColorChange: (color) {
                                    colorModel.backgroundSecondColor =
                                        color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'ل'
                                          'ون الخطر'
                                      : 'Danger Color',
                                  initColor: colorModel.dangerColor != null
                                      ? Color(colorModel.dangerColor!)
                                      : ThemeService.dangerColor,
                                  onColorChange: (color) {
                                    colorModel.dangerColor = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'لون الخط الغير مفعل في '
                                          'القائمة'
                                      : 'Inactive Menu Text Color',
                                  initColor: colorModel.inactiveMenuTextColor !=
                                          null
                                      ? Color(colorModel.inactiveMenuTextColor!)
                                      : ThemeService.inactiveMenuTextColor,
                                  onColorChange: (color) {
                                    colorModel.inactiveMenuTextColor =
                                        color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'اللون الرئيسي'
                                      : 'Main Color',
                                  initColor: colorModel.mainColor != null
                                      ? Color(colorModel.mainColor!)
                                      : ThemeService.mainColor,
                                  onColorChange: (color) {
                                    colorModel.mainColor = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'ا'
                                          'للون الرئيسي الثاني'
                                      : 'Main Color 2',
                                  initColor: colorModel.mainColor2 != null
                                      ? Color(colorModel.mainColor2!)
                                      : ThemeService.mainColor2,
                                  onColorChange: (color) {
                                    colorModel.mainColor2 = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'اللون الفرعي الخفيف'
                                      : 'Sub Color '
                                          'Light',
                                  initColor: colorModel.subColorLight != null
                                      ? Color(colorModel.subColorLight!)
                                      : ThemeService.subColorLight,
                                  onColorChange: (color) {
                                    colorModel.subColorLight = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'لون نجاح العملية'
                                      : 'Success Color',
                                  initColor: colorModel.successColor != null
                                      ? Color(colorModel.successColor!)
                                      : ThemeService.successColor,
                                  onColorChange: (color) {
                                    colorModel.successColor = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'لون الخط المفعل'
                                      : 'Text Selected '
                                          'Color',
                                  initColor:
                                      colorModel.textSelectedColor != null
                                          ? Color(colorModel.textSelectedColor!)
                                          : ThemeService.textSelectedColor,
                                  onColorChange: (color) {
                                    colorModel.textSelectedColor = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'ل'
                                          'ون الخط الفرعي '
                                      : 'Text Sub Color',
                                  initColor: colorModel.textSubColor != null
                                      ? Color(colorModel.textSubColor!)
                                      : ThemeService.textSubColor,
                                  onColorChange: (color) {
                                    colorModel.textSubColor = color.value;
                                    setState(() {});
                                  }),
                              _chooseColor(
                                  name: LocalConfigService.isArabic
                                      ? 'ل'
                                          'ون التحذير'
                                      : 'Warning Color',
                                  initColor: colorModel.worningColor != null
                                      ? Color(colorModel.worningColor!)
                                      : ThemeService.worningColor,
                                  onColorChange: (color) {
                                    colorModel.worningColor = color.value;
                                    setState(() {});
                                  }),
                            ],
                          ),
                        ),
                      ),
                      bottomNavigationBar: Padding(
                        padding: EdgeInsets.all(10),
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                          children: <Widget>[
                            MaterialButton(
                              onPressed: () async {
                                if (colorModel != null) {
                                  ConfigService.setValueMap(
                                          'appColors', colorModel.toJson())
                                      .then((value) {
                                    if (value) {
                                      AppNavigator.showMessage(
                                          context,
                                          'تم '
                                          'الحفظ يجب إعادة تشغيل البرنامج '
                                          'لتفعيل الألوان الجديدة',
                                          MessageType.info);
                                    }
                                  });
                                } else {
                                  AppNavigator.showMessage(
                                      context,
                                      'لم يحدث '
                                      'تغير في أي لون من الألوان',
                                      MessageType.error);
                                }
                              },
                              child: Text(trans('Save')),
                            ),
                            MaterialButton(
                                onPressed: () {
                                  ConfigService.setValueMap('appColors', {})
                                      .then((value) => AppNavigator.showMessage(
                                          context,
                                          LocalConfigService.isArabic
                                              ? 'تم الرجوع إلي الألوان '
                                                  'الإفتراضية أعد تشغيل '
                                                  'البرنامج لتفعيل '
                                                  'الألوان الإفتراضية.'
                                              : 'Default '
                                                  'Colors '
                                                  'has been loaded, please '
                                                  'restart the application',
                                          MessageType.success));
                                },
                                child: Text(trans('Default Settings'))),
                          ],
                        ),
                      ),
                    ),
                  );
                },
                child: Text('تغير ألوان البرنامج')),
            null),
        SizedBox(height: 15.0),
        _getItem(
            'Enable Development Mode',
            Switch(
                value: ConfigService.getValueBool('DevelopmentMode'),
                onChanged: (v) {
                  ConfigService.setValueBool('DevelopmentMode', v);
                  setState(() {
                    //AppNavigator.navigateToNamed(context, '/');
                    Navigator.pushNamedAndRemoveUntil(
                        context, '/', (route) => false);
                  });
                }),
            null,
            tooltipMessage: LocalConfigService.isArabic
                ? 'يمكنك تفعيل '
                    'هذه الخاصية إذا كنت تريد تغير النص عن طريق الضغطة المطولة علي أي'
                    ' نص في البرنامج'
                : 'You can active it if you want to change whole '
                    'labels in application by holding long press on any text'),
        SizedBox(height: 15.0),
      ],
    ));
  }

  Widget _getItem(String title, Widget child, Widget? tools,
      {String? tooltipMessage}) {
    return Card(
      margin: EdgeInsets.symmetric(horizontal: 15.0),
      surfaceTintColor: Colors.white,
      shadowColor: Colors.white,
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.stretch,
        children: <Widget>[
          Container(
            height: 45.0,
            color: ThemeService.backgroundSecondColor,
            child: Padding(
                padding: EdgeInsets.symmetric(horizontal: 10),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.start,
                  children: [
                    Align(
                      alignment: LocalConfigService.isArabic
                          ? Alignment.centerRight
                          : Alignment.centerLeft,
                      child: TecfyText(
                        AppLocale.translate(title),
                        style: Theme.of(context).textTheme.caption,
                      ),
                    ),
                    SizedBox(
                      width: 20,
                    ),
                    if (tooltipMessage != null)
                      Tooltip(
                        message: tooltipMessage,
                        child: Icon(
                          Icons.info_outline_rounded,
                          color: Colors.grey.shade500,
                        ),
                      ),
                    tools ?? const SizedBox()
                  ],
                )),
          ),
          //item('Account Information', ()=>AccountPage())
          Container(
            height: 70.0,
            color: Colors.white,
            margin: EdgeInsets.symmetric(horizontal: 10),
            child: Align(
                alignment: LocalConfigService.isArabic
                    ? Alignment.centerRight
                    : Alignment.centerLeft,
                child: child),
          )
        ],
      ),
    );
  }
}
